This is ncftp compiled for MiNT using ncurses 1.9.9e.

Please read this file entirely.  It's quite boring to refer to the
READMEs over and over again when replying to comments or bug reports.

Ncftp is a (n)curses based ftp client, i.e. in comparison to the standard
ftp client it uses a full-screen user interface.  Compared to the standard
ftp it has many powerful new features, like recursive up/download, command
history, bookmarks, http URLs, exhaustive help functions...

System requirements
===================

Ncftp requires MiNT and MiNTnet, you can't user it with other TCP/IP
stacks than MiNTNet.  Due to the curses based user interface ncftp
also requires either a termcap or terminfo installation.  Check if
the file /etc/termcap or the directories /usr/local/lib/terminfo
or /usr/lib/terminfo exist.  If one of them exists it should be
ok (see `Ncurses' below for details).

Ncftp doesn't use loads of memory, 512k of free RAM should be alright.

You should also have the programs /bin/more (or /bin/less) and
/bin/cat although this is not essential for the standard functionality.

Installation
============

Very easy.  The executable `ncftp' should be installed somewhere
in your $PATH.  The manpages should be installed in your $MANPATH.
If you simply copy the folder `usr' in this distribution to the
root directory of your minix partition everything should be in 
place.

Bugs
====

- Problems have been reported for upload of huge files (> 500k).  The
upload may stop at an average of 500k.  However I can't reproduce the
bug, so I can't tell if it's a bug in ncftp, in /this/ port of ncftp,
or a deficiency of the particular ftp server or ...

- After viewing remote files with the builtin `cat' command the screen
gets messed up.  If you type <CTRL>-L the screen will be repainted and
everything should look fine again.

- Not really a bug:  This binary is compiled without the socks5 firewall
traversal library.  Maybe I'll have another try later, right now I can't
get it to work alright.

- The very first time a user starts ncftp you might see very strange
things and need a lot of patience.  Please, please read the section
`ncurses' before cursing about that too much. ;-)

Sources & Diffs
===============

See README for information on how to get the ncftp sources.  You should
find it on a large number of ftp servers somewhere in the GNU directory.
This distribution contains no diffs since there were no diffs necessary
to build ncftp.

However, ncftp won't build without ncurses.  You can find ncurses 
on ftp://prep.ai.mit.edu/pub/gnu/ncurses...  There's no binary port to 
MiNT available, but at least version 1.9.9e compiles rigth away.

Ncurses
=======

Curses based programs have to get information about the terminal
they are running on; they have to know for example what characters
are necessary to print in order to move up the cursor a line, or
to clear the screen, or to erase a line, to display bold or reversed
characters and so on.

Two different concepts exist to fulfill these needs.  Most MiNT
systems will have the termcap database installed.  A program can
extract all necessary informations (i.e. terminal capabilities) from
the (human-readable) file /etc/termcap.  The termcap mechanism is
considered obsolete nowadays since it suffers from various deficiencies.

A more efficient approach is the terminfo mechanism.  Instead of
one huge description file (/etc/termcap tends to be very large)
the information is structured in a directory tree.  Instead of
human readable ASCII-files (which have to be interpreted by the
program first) the descriptions are put into a compiled binary
form.

Example:  You use TOSWIN as your terminal emulator.  Most versions
of TOSWIN will set the environment variable $TERM to `tw52'.  A
termcap based program will search through /etc/termcap until it
finds an entry for `tw52'.  Then it will extract the information
and will convert it internally into some binary representation.

A terminfo program will (roughly) look for the directories
/usr/local/lib/terminfo or /usr/lib/terminfo.  If it finds for
example /usr/local/lib/terminfo it will then look for a file
/usr/local/lib/terminfo/t/tw52 that contains the required information
already in a converted, binary form.  This procedure performs
much quicker than the termcap mechanism.

Furthermore the terminfo database offers much more capabilities
which weren't available when using the termcap stuff (e.g. color,
mouse support, ...)

But what will happen if the program can't find the terminfo database
in the standard places?  I've configured my ncurses library in a way
that offers a fallback mechanism for older systems without the
terminfo database.  If the program can't find the terminfo database
it will scan /etc/termcap instead, will extract the information from
there, compile it and will then build a mini terminfo database in
your home directory.  If your home directory is /home/myname you
will find the result in /home/myname/.terminfo (note the dot, the
directory will be hidden).  The next time you start the program
it will find this mini database and won't have to redo all that 
stuff.

Now for the problem:  The program scans the entire file /etc/termcap
and this will take some time.  To tell you the truth it probably
won't take some seconds but rather some minutes depending on the
size.  Furthermore it will come across a lot of errors and will 
report these errors.

Please be patient during this process.  As long as the error messages
don't apply to a terminal you use (which is very likely) you can
completely ignore all errors and warnings.

Good news:  The process will be necessary only once for each user.
The next time you start the program it will accept the terminfo
database in your home directory without any complaints and you
don't have to wait at all at program startup.  And if you see
how comfortable the program's user interface is you will understand
that it was worth waiting.

If you want to speed up things for all users at once do the following.
Start the program once and wait until the terminfo database is built.
Now copy the directory `.terminfo' from your home directory to
a directory `terminfo' (without dot) in /usr/local/lib.  Every
user can access this database.  This will save both time and disk space.

If you think that you haven't understood all this:  Simply start the
program, go away have a cup of coffee and a cigarette and then
forget about the whole thing for ever.  You will never be reminded
to it again.

Hope you have fun with ncftp!

Guido Flohr
--
http://stud.uni-sb.de/~gufl0000/
mailto:gufl0000@stud.uni-sb.de
